var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8, _templateObject9, _templateObject10, _templateObject11, _templateObject12, _templateObject13, _templateObject14, _templateObject15, _templateObject16, _templateObject17, _templateObject18, _templateObject19, _templateObject20;

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/*
 * @license
 * Copyright Ahmed Elywa. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */
import styled, { css } from 'styled-components';
import { breakpointDown } from '../breakpoints';
import SidebarStyle from '../Sidebar/style';
import { scrollbars } from '../utils';
var LayoutContainer = styled.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  display: flex;\n  flex: 1;\n  -ms-flex: 1 1 auto;\n  flex-direction: row;\n"])));
var LayoutContent = styled.div(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  ", "\n"])), function (_ref) {
  var theme = _ref.theme,
      center = _ref.center;
  return css(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n    display: flex;\n    flex: 1;\n    -ms-flex: 1 1 auto;\n    flex-direction: column;\n    min-width: 0;\n    ", "\n  "])), center && css(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n      max-width: 100%;\n      position: relative;\n      margin-left: auto;\n      margin-right: auto;\n      width: ", ";\n      flex: 0 100 ", " !important;\n    "])), theme.layoutContentWidth, theme.layoutContentWidth));
});
var LayoutColumns = styled.div(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n  display: flex;\n  -ms-flex: 1 1 auto;\n  flex: 1;\n  flex-direction: row;\n  width: 100%;\n"])));
var LayoutColumn = styled.div(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral(["\n  ", "\n"])), function (_ref2) {
  var theme = _ref2.theme,
      position = _ref2.position;
  return css(_templateObject7 || (_templateObject7 = _taggedTemplateLiteral(["\n    order: 1;\n    flex: 1 0;\n    min-width: 0;\n    padding: ", ";\n\n    ", "\n\n    ", "\n\n    ", "\n  "])), theme.layoutPadding, position === 'left' ? theme.dir === 'rtl' ? 'order: 2;' : 'order: 0;' : position === 'start' && 'order: 0;', breakpointDown('md')(_templateObject8 || (_templateObject8 = _taggedTemplateLiteral(["padding: ", ";"])), theme.layoutMediumPadding), breakpointDown('sm')(_templateObject9 || (_templateObject9 = _taggedTemplateLiteral(["padding: ", ";"])), theme.layoutSmallPadding));
});
var HeaderStyle = styled.header(_templateObject10 || (_templateObject10 = _taggedTemplateLiteral(["\n  ", "\n"])), function (_ref3) {
  var theme = _ref3.theme;
  return css(_templateObject11 || (_templateObject11 = _taggedTemplateLiteral(["\n    background-color: ", ";\n    color: ", ";\n    font-family: ", ";\n    font-size: ", ";\n    font-weight: ", ";\n    line-height: ", ";\n    display: block;\n    nav {\n      color: ", ";\n      box-shadow: ", ";\n      height: ", ";\n      padding: ", ";\n      align-items: center;\n      justify-content: flex-start;\n      display: flex;\n      a {\n        color: ", ";\n        &:hover,\n        &:focus,\n        &:active {\n          color: ", ";\n        }\n      }\n    }\n    & ~ ", " {\n      min-height: calc(", ");\n    }\n\n    &.fixed {\n      position: fixed;\n      top: 0;\n      left: 0;\n      right: 0;\n      z-index: 1040;\n      & ~ ", " {\n        padding-top: ", ";\n        min-height: ", ";\n      }\n      ~ ", " > aside > .main-container {\n        height: calc(", ");\n      }\n    }\n  "])), theme.headerBackgroundColor, theme.headerTextColor, theme.headerTextFontFamily, theme.headerTextFontSize, theme.headerTextFontWeight, theme.headerTextLineHeight, theme.headerTextColor, theme.headerShadow, theme.headerHeight, theme.headerPadding, theme.headerTextColor, theme.headerTextColor, LayoutContainer, theme.layoutMinHeight + ' - ' + theme.headerHeight, LayoutContainer, theme.headerHeight, theme.layoutMinHeight, LayoutContainer, theme.sidebarHeight + ' - ' + theme.headerHeight);
});
var FooterStyle = styled.footer(_templateObject12 || (_templateObject12 = _taggedTemplateLiteral(["\n  ", "\n"])), function (_ref4) {
  var theme = _ref4.theme;
  return css(_templateObject13 || (_templateObject13 = _taggedTemplateLiteral(["\n    display: block;\n    margin-top: auto;\n    box-shadow: ", ";\n    nav {\n      justify-content: center;\n      display: flex;\n      background-color: ", ";\n      border-top: ", " ", " ", ";\n      color: ", ";\n      font-family: ", ";\n      font-size: ", ";\n      font-weight: ", ";\n      line-height: ", ";\n      padding: ", ";\n      a {\n        color: ", ";\n        &:hover,\n        &:focus,\n        &:active {\n          color: ", ";\n        }\n      }\n    }\n  "])), theme.footerShadow, theme.footerBackgroundColor, theme.footerDividerWidth, theme.footerDividerStyle, theme.footerDividerColor, theme.footerTextColor, theme.footerTextFontFamily, theme.footerTextFontSize, theme.footerTextFontWeight, theme.footerTextLineHeight, theme.footerPadding, theme.footerTextHighlightColor, theme.footerTextHighlightColor);
});

var getWindowMode = function getWindowMode(theme, padding, action) {
  return css(_templateObject14 || (_templateObject14 = _taggedTemplateLiteral(["\n    padding-top: calc(", " / ", ");\n\n    ", ".fixed {\n      top: calc(", " / ", ");\n    }\n\n    ", ".fixed ~ .layout-container ", " .main-container-fixed {\n      height: calc(100vh - calc(", " / ", ") - ", ");\n      top: calc(calc(", " / ", ") + ", ");\n    }\n    ", ".fixed {\n      left: calc((100vw - ", ") / 2);\n    }\n\n    .layout ", " {\n      ", ".fixed.right {\n        right: calc((100vw - ", ") / 2);\n      }\n\n      ", ".fixed {\n        top: calc(", " + calc(", " / ", "));\n      }\n    }\n\n    .scrollable-container {\n      height: calc(100vh - calc(", " / ", "));\n      box-shadow: ", ";\n    }\n  "])), padding, action, HeaderStyle, padding, action, HeaderStyle, SidebarStyle, padding, action, theme.headerHeight, padding, action, theme.headerHeight, SidebarStyle, theme.layoutWindowModeMaxWidth, LayoutContainer, SidebarStyle, theme.layoutWindowModeMaxWidth, SidebarStyle, theme.headerHeight, padding, action, padding, action, theme.layoutWindowShadow);
};

var LayoutStyle = styled.div(_templateObject15 || (_templateObject15 = _taggedTemplateLiteral(["\n  ", "\n"])), function (_ref5) {
  var theme = _ref5.theme,
      withScroll = _ref5.withScroll,
      windowMode = _ref5.windowMode,
      withSubHeader = _ref5.withSubHeader;
  var windowPadding = theme.layoutWindowModePaddingTop;
  return css(_templateObject16 || (_templateObject16 = _taggedTemplateLiteral(["\n      text-align: ", ";\n      -webkit-font-smoothing: antialiased;\n\n      .scrollable-container {\n        ", "\n      }\n      .layout {\n        display: flex;\n        flex-direction: column;\n        min-width: ", ";\n      }\n\n      ", "\n\n      ", "\n      .layout {\n        background-color: ", ";\n        color: ", ";\n        font-family: ", ";\n        font-size: ", ";\n        font-weight: ", ";\n        line-height: ", ";\n        min-height: ", ";\n      }\n      ", "\n      #overlay-container {\n        position: fixed;\n        z-index: 1040;\n        pointer-events: none;\n        top: 0;\n        left: 0;\n        height: 100%;\n        width: 100%;\n      }\n    "])), theme.dir === 'rtl' ? 'right' : 'left', scrollbars(theme.layoutScrollbarColor, theme.layoutScrollbarBackgroundColor, theme.layoutScrollbarWidth), theme.layoutWindowModeMinWidth, (withScroll || windowMode) && css(_templateObject17 || (_templateObject17 = _taggedTemplateLiteral(["\n        .scrollable-container {\n          overflow: auto;\n          height: 100vh;\n          display: block;\n          ", "\n        }\n      "])), breakpointDown('sm')(_templateObject18 || (_templateObject18 = _taggedTemplateLiteral(["\n              overflow-y: scroll;\n              -webkit-overflow-scrolling: touch;\n            "])))), windowMode && css(_templateObject19 || (_templateObject19 = _taggedTemplateLiteral(["\n        background: ", ";\n        display: block;\n        .scrollable-container {\n          max-width: ", ";\n          margin: 0 auto;\n        }\n\n        .layout ", " {\n          max-width: ", ";\n          margin-left: auto;\n          margin-right: auto;\n          width: 100%;\n          nav {\n            max-width: ", ";\n            margin: 0 auto;\n          }\n        }\n\n        @media screen and (min-width: ", " + 20px) {\n          ", "\n\n          #oah-layout.with-scroll {\n            .scrollable-container {\n              height: calc(100vh - ", ");\n            }\n          }\n        }\n        @media screen and (min-width: ", " + 150px) {\n          ", "\n\n          #oah-layout.with-scroll {\n            .scrollable-container {\n              height: calc(100vh - ", ");\n            }\n          }\n        }\n        @media screen and (min-width: ", " + 300px) {\n          ", "\n\n          #oah-layout.with-scroll {\n            .scrollable-container {\n              height: calc(100vh - ", ");\n            }\n          }\n        }\n      "])), theme.layoutWindowModeBackgroundColor, theme.layoutWindowModeMaxWidth, HeaderStyle, theme.layoutWindowModeMaxWidth, theme.layoutWindowModeMaxWidth, theme.layoutWindowModeMaxWidth, getWindowMode(theme, windowPadding, 4), windowPadding, theme.layoutWindowModeMaxWidth, getWindowMode(theme, windowPadding, 2), windowPadding, theme.layoutWindowModeMaxWidth, getWindowMode(theme, windowPadding, 1), windowPadding), theme.layoutBackgroundColor, theme.layoutTextColor, theme.layoutTextFontFamily, theme.layoutTextFontSize, theme.layoutTextFontWeight, theme.layoutTextLineHeight, theme.layoutMinHeight, withSubHeader && css(_templateObject20 || (_templateObject20 = _taggedTemplateLiteral(["\n        ", " .main-container {\n          box-shadow: none;\n        }\n      "])), SidebarStyle));
});
export { LayoutStyle, LayoutContainer, LayoutContent, LayoutColumns, LayoutColumn, HeaderStyle, FooterStyle };